#ifndef _FILECOPIER_H_
#include "file.h"
#include "filePath.h"
#include "copyProgress.h"
#include "diskSpace.h"

class fileCopySet
{ private:
		FileVector    fileList;
  	FilePath      sourceDir;
		unsigned long	dataSize;
  public:
  	FilePath      destDir;
    fileCopySet();
  	fileCopySet(FileVector files, FilePath &from, FilePath &to);
	  char *destination(File *file);
    unsigned long getOriginalSize();
    unsigned long getCopiedSize(DiskSpace &space);
    bool copyFile(File *file, copyProgressBar &progressBar);
    void copy(File *file, copyProgressBar &progressBar);
    void copy(copyProgressBar &progressBar);
};

typedef vector<fileCopySet> fileCopySetList;

class fileCopier
{ private:
		fileCopySetList	list;
		unsigned long		dataSize;
  	unsigned long 	copied;
	  copyProgressBar progressBar;
	protected:
  public:
  	fileCopier::fileCopier(fileCopySetList &list);
    fileCopier::fileCopier();
    void fileCopier::addSet(fileCopySet &set) { this->list.push_back(set); }
    bool checkSpace();
    void copy();
};
#define _FILECOPIER_H_
#endif
